require("include")

function love.load()
	screen = {}
		screen.width = love.graphics.getWidth()
		screen.height = love.graphics.getHeight()
	mouseX = love.mouse.getX()
	mouseY = love.mouse.getY()
	mainFont = love.graphics.newFont(12)
	noise.load()
	map.load()
	player.load()
	time.load()
	states.load()
	gui.load()
	buttons.load()

end

function love.draw()
	if states.game == 1 then
		--PLAYING
		love.graphics.setBackgroundColor(0,100,255)
		map.draw()
		player.draw()
		deer.draw()
		--plants.draw()
		plantDraw()
		
		gui.draw()
	elseif states.game == 2 then
		--PAUSED
	end

	if health.value == 0 then
		player.death()
	end

	if states.debug == true then
		debug.draw()
	end
	buttons.draw()
end

function love.update(dt)
	if screen.width < love.graphics.getWidth() or screen.width > love.graphics.getWidth() or screen.height < love.graphics.getHeight() or screen.height > love.graphics.getHeight() then
		screen.width = love.graphics.getWidth()
		screen.height = love.graphics.getHeight()
		screen.changed = true
	end
	if mouseX < love.mouse.getX() or mouseX > love.mouse.getX() or mouseY < love.mouse.getY() or mouseY > love.mouse.getY() then
		mouseX = love.mouse.getX()
		mouseY = love.mouse.getY()
	end
	player.control(dt)
	--deer.update(dt)
	--plants.update(dt)
	time.update(dt)
	gui.update(dt)
	buttons.update(dt)
	plantUpdate(dt)

	if screen.changed == true then
		screen.changed = false
	end
end

function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end
	debug.keypressed(key)

	if key == "o" then
		health.value = 0
	end
end

function love.mousepressed(x,y,button)
	buttons.mousepressed(x,y,button)
	Plant:mousepressed(x,y,button)
end