objectList = {}

Plant = {}
Plant.__index  = Plant

berryBushFull = love.graphics.newImage("assets/images/berryBushFull.png")
berryBushEmpty = love.graphics.newImage("assets/images/berryBushEmpty.png")


function Plant:new(x,y,id)
	plant = setmetatable({}, Plant)
	plant.x = x
	plant.y = y
	if id == 1 then
		plant.img = berryBushFull
	end
	plant.w = plant.img:getWidth()
	plant.h = plant.img:getHeight()
	plant.canHarvest = true
	plant.red = 255
	plant.green = 0
	plant.harvestProgress = 0
	plant.harvested = "false"
	return plant
end

function Plant:draw()
	if self.harvested == "true" then
		plant.img = berryBushEmpty
	end
	love.graphics.draw(self.img, self.x, self.y)
	if self.canHarvest == true then
		love.graphics.setColor(self.red, self.green, 0, 255)
		love.graphics.rectangle("fill", player.x - 16, player.y + player.height + 10, 64, 10)
		love.graphics.setColor(255, 255, 255, 255)
	end
	love.graphics.print("plant harvested = "..self.harvested, 0, 0)
	love.graphics.print(self.harvestProgress, 0, 15)
end

function Plant:update(dt)
	if player.x + 16 >= self.x and player.x + 16 <= self.x + self.w and player.y + 32 >= self.y and player.y + 32 <= self.y + self.h and self.harvested == "false" then
		self.canHarvest = true
	else
		self.canHarvest = false
	end

	if love.keyboard.isDown("space") and self.harvestProgress < 255 then
		self.red = self.red - 2
		self.green = self.green + 2
		self.harvestProgress = self.harvestProgress + 2
	elseif self.harvestProgress >= 255 and love.keyboard.isDown("space") then
		self.red = 0
		self.green = 255
		self.harvestProgress = 255
		self.harvested = "true"
		self.canHarvest = false
	end

	if not love.keyboard.isDown("space") and self.harvestProgress < 255 then
		self.red = 255
		self.green = 0
		self.harvestProgress = 0
	end
end

function Plant:mousepressed(x,y,button)
	if button == 3 then
		objectList[#objectList+1] = Plant:new(x,y,1)
	end
end

function Plant.keypressed(key)
end

function plantUpdate(dt)
	for i = 1,#objectList do
		if objectList[i].update then objectList[i]:update(dt) end
	end
end

--function plantMousepressed(x,y,button)
--	for i = 1,#objectList do
--		if objectList[i].mousepressed then objectList[i]:mousepressed(x,y,button) end
--	end
--end

function plantKeypressed(key)
	for i = 1,#objectList do
		if objectList[i].keypressed then objectList[i]:keypressed(key) end
	end
end

function plantDraw()
	for i = 1,#objectList do
		objectList[i]:draw()
	end
end